# GroupDocs.Signature-for-Java-Servlet Example
###### version 1.1.0


## System Requirements
- Java 8 (JDK 1.8)
- Maven 3


## Description
GroupDocs.Signature is a native, simple, fully configurable and optimized web application which allows you to manipulate documents without requiring any other commercial application through GroupDocs APIs.

**Note** Without a license application will run in trial mode, purchase [GroupDocs.Signature for Java license](https://purchase.groupdocs.com/order-online-step-1-of-8.aspx) or request [GroupDocs.Signature for Java temporary license](https://purchase.groupdocs.com/temporary-license).


## Demo Video
Coming soon


## Features
- Clean, modern and intuitive design
- Easily switchable colour theme (create your own colour theme in 5 minutes)
- Responsive design
- Mobile support (open application on any mobile device)
- Support over 50 documents and image formats
- Image mode
- Fully customizable navigation panel
- Sign password protected documents
- Download original documents
- Download signed documents
- Upload documents
- Upload signatures
- Sign document with such signature types: digital certificate, image, stamp, qrCode, barCode.
- Draw signature image
- Draw stamp signature
- Generate bar code signature
- Generate qr code signature
- Print document
- Smooth page navigation
- Smooth document scrolling
- Preload pages for faster document rendering
- Multi-language support for displaying errors
- Cross-browser support (Safari, Chrome, Opera, Firefox)
- Cross-platform support (Windows, Linux, MacOS)


## How to run
1. Download/Clone GroupDocs.Signature for Java Servlet Sample.
2. Extract/Copy GroupDocs.Signature for Java Servlet Sample to working directory.
3. Navigate to GroupDocs.Signature for Java Servlet Sample root directory.
4. Update parameters in `src/main/resources/configuration.properties` to meet your requirements.
5. Open console and type `cd 'GroupDocs.Signature for Java Servlet Sample root directory'`, press enter.
6. From console type following command: `mvn clean jetty:run`, press enter.
7. Go to `http://localhost:8080/signature/`.



[Home](https://www.groupdocs.com/) | [Product Page](https://products.groupdocs.com/signature/java) | [Documentation](https://docs.groupdocs.com/signature/java/) | [Demos](https://products.groupdocs.app/signature/family) | [API Reference](https://apireference.groupdocs.com/signature/java) | [Examples](https://github.com/groupdocs-Signature/GroupDocs.Signature-for-Java/tree/master/Examples) | [Blog](https://blog.groupdocs.com/category/signature/) | [Free Support](https://forum.groupdocs.com/c/signature) | [Temporary License](https://purchase.groupdocs.com/temporary-license)
