---
id: supported-document-formats
url: signature/java/supported-document-formats
title: Supported Document Formats
weight: 2
description: ""
keywords: 
productName: GroupDocs.Signature for Java
hideChildren: False
---
The following table indicates the file formats that GroupDocs.Signature can work with.

| Format | Description | Barcode | Digital | FormField | Image | Metadata | QR-code | Stamp | Text |
| --- | --- | --- | --- | --- | --- | --- | --- | --- | --- |
| [BMP](https://wiki.fileformat.com/image/bmp/) | Bitmap Picture (BMP) | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [CDR](https://wiki.fileformat.com/image/cdr/) | CorelDraw Vector Graphic Drawing (CDR) | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [CMX](https://wiki.fileformat.com/image/cmx/) | Corel Metafile eXchange Image | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png)  |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [DJVU](https://wiki.fileformat.com/image/djvu/) | Deja Vu (DjVu) | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png)  |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [GIF](https://wiki.fileformat.com/image/gif/) | Graphics Interchange Format (GIF) | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png)  |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [JPG](https://wiki.fileformat.com/image/jpeg/), [JPEG](https://wiki.fileformat.com/image/jpeg/)   | Joint Photographic Experts Group (JPEG) | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png)  | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [PNG](https://wiki.fileformat.com/image/png/) | Portable Network Graphics (PNG) | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png)  | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [PSD](https://wiki.fileformat.com/image/psd/) | Adobe Photoshop Document (PSD) | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png)  | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [SVG](https://wiki.fileformat.com/page-description-language/svg/) | Scalable Vector Graphics (SVG) | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png)  | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [TIF](https://wiki.fileformat.com/specification/image/tiff/)[, ](https://wiki.fileformat.com/image/tiff/)[TIFF](https://wiki.fileformat.com/specification/image/tiff/) | Tagged Image File Format (TIFF) | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png)  | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [WEBP](https://wiki.fileformat.com/image/webp/) | WebP Image | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png)  |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [WMF](https://wiki.fileformat.com/image/wmf/) | Windows Metafile (WMF) | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png)  |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [PDF](https://wiki.fileformat.com/view/pdf/) | Adobe Portable Document Format (PDF) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [ODP](https://wiki.fileformat.com/presentation/odp/) | OpenDocument Presentation | ![(tick)](signature/java/images/check.png) |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [OTP](https://wiki.fileformat.com/presentation/otp/) | OpenDocument Presentation Template | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [POTM](https://wiki.fileformat.com/presentation/potm/) | Microsoft PowerPoint Macro-Enabled Template | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [POTX](https://wiki.fileformat.com/presentation/potx/) | Microsoft PowerPoint Template | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [PPS](https://wiki.fileformat.com/presentation/pps/) | Microsoft PowerPoint 97-2003 Slide Show | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [PPSM](https://wiki.fileformat.com/presentation/ppsm/) | Microsoft PowerPoint Macro-Enabled Slide Show | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [PPSX](https://wiki.fileformat.com/presentation/ppsx/) | Microsoft PowerPoint Slide Show | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [PPT](https://wiki.fileformat.com/presentation/ppt/) | Microsoft PowerPoint 97-2003 Presentation | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [PPTM](https://wiki.fileformat.com/presentation/pptm/) | Microsoft PowerPoint Macro-Enabled Presentation | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [PPTX](https://wiki.fileformat.com/presentation/pptx/) | Microsoft PowerPoint Presentation | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [ODS](https://wiki.fileformat.com/spreadsheet/ods/) | OpenDocument Spreadsheet | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| OTS | OpenDocument Spreadsheet Template | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [XLSX](https://wiki.fileformat.com/spreadsheet/xlsx/) | Microsoft Excel Worksheet | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [XLS](https://wiki.fileformat.com/spreadsheet/xls/) | Microsoft Excel 97-2003 Worksheet | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [XLSB](https://wiki.fileformat.com/spreadsheet/xlsb/) | Microsoft Excel Binary Worksheet | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [XLSM](https://wiki.fileformat.com/spreadsheet/xlsm/) | Microsoft Excel Macro-Enabled Worksheet | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [XLTX](https://wiki.fileformat.com/spreadsheet/xltx/) | Microsoft Excel template | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [XLTM](https://wiki.fileformat.com/spreadsheet/xltm/) | Microsoft Excel macro-enabled template | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [DOC](https://wiki.fileformat.com/word-processing/doc/) | Microsoft Word 97-2003 Document | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [DOCM](https://wiki.fileformat.com/word-processing/docm/) | Microsoft Word Macro-Enabled Document | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [DOCX](https://wiki.fileformat.com/word-processing/docx/) | Microsoft Word Document | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [DOT](https://wiki.fileformat.com/word-processing/dot/) | Microsoft Word 97-2003 Template | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [DOTM](https://wiki.fileformat.com/word-processing/dotm/) | Microsoft Word Macro-Enabled Template | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [DOTX](https://wiki.fileformat.com/word-processing/dotx/) | Microsoft Word Template | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [ODT](https://wiki.fileformat.com/word-processing/odt/) | OpenDocument Text | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
| [OTT](https://wiki.fileformat.com/word-processing/ott/) | OpenDocument Text Template | ![(tick)](signature/java/images/check.png) |   |   | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) | ![(tick)](signature/java/images/check.png) |
